//+------------------------------------------------------------------+
//|  ( FXPM+++ v4.0 )                                             |
//+------------------------------------------------------------------+

#property description "FXPM+++ v4.0"
#property indicator_chart_window

input int   numTimeFrames  = 9;
int          Spacing       = 24;
int          Width         = 23;
int          MA_mode       = 0;
input int    Grid_Range    = 85;

int          VWidth = 24;

extern color LineColor= C'109,109,109';
extern color Fib_price_color_high= C'27,33,39';
extern color Fib_price_color_low= C'27,33,39';
extern color neutral_col= C'39,51,60';
extern color up_col_1= C'32,41,49' ;
extern color up_col_2= C'32,41,49' ;
extern color up_col_3= C'32,41,49' ;
extern color up_col_4= C'32,41,49' ;
extern color up_col_5= C'32,41,49' ;
extern color up_col_6= C'32,41,49' ;
extern color down_col_1= C'32,41,49' ;
extern color down_col_2= C'32,41,49' ;
extern color down_col_3= C'32,41,49' ;
extern color down_col_4= C'32,41,49' ;
extern color down_col_5= C'32,41,49' ;
extern color down_col_6= C'32,41,49' ;
input color fibPoints_R_Color=C'183,255,255';
input color fibPoints_S_Color=C'193,255,193';
input color fibPoints_R_Color_Week=C'255,217,222';
input color fibPoints_S_Color_Week=C'216,254,216';
input color fibPoints_R_Color_Monthly=C'255,149,165';
input color fibPoints_S_Color_Monthly=C'100,249,100';

extern bool show_Fibo_Point=true;
extern bool show_Fibo_Point_Price=true;
extern bool show_Fibo_Point_Week=true;
extern bool show_Fibo_Point_Price_Week=true;
extern bool show_Fibo_Point_Monthly=true;
extern bool show_Fibo_Point_Monthly_Price=true;
extern bool Show_bid=True;

extern bool Fib_Box=true;
extern bool Diamond_Direction=true;

input color DiamondWeakDirection0=C'186,252,186';
input color DiamondWeakDirection1=C'255,162,145';
input color DiamondDirectionWeakAverage0=C'124,250,124';
input color DiamondDirectionWeakAverage1=C'255,134,113';
input color DiamondDirectionStrongAverage0=C'0,203,0';
input color DiamondDirectionStrongAverage1=C'255,90,90';
input color DiamondDirectionStrong0=C'0,106,0';
input color DiamondDirectionStrong1=C'236,0,0';

extern bool D1_Show_Line=True;
extern bool D1_Show_Price=True;
input color D1_Highcol = C'224,120,44';
input color D1_Lowcol = C'224,120,44';
input int D1_style = 2;
extern bool Show_Daily_Info=true;

extern bool W1_Show_Line=true;
extern bool W1_Show_Price=true;
input color W1_Highcol = C'166,120,104';
input color W1_Lowcol = C'166,120,104';
input int W1_style = 2;

extern bool MN1_Show_Line=true;
extern bool MN1_Show_Price=true;
input color MN1_Highcol = C'255,222,206';
input color MN1_Lowcol = C'255,222,206';
input int MN1_style = 2;

extern bool XD1_Show_Line=true;
extern bool XD1_Show_Price=true;
input color XD1_Highcol = C'244,237,149';
input color XD1_Lowcol = C'244,237,149';
input int XD1_style = 2;

extern bool Open_Show_Line=true;
extern bool Open_Show_Price=true;
input color Open_col = clrWhite;
input int Open_style = 2;

extern bool Show_BB_Candle=true;
extern int BBWidth = 10;
input color TailCol = C'197,197,197';
input color BullCol = C'70,142,142';
input color BearCol = C'70,142,142';
input color OBCol = C'255,157,17';
input color OSCol = C'25,139,255';

//input color fibDownColor=clrMediumSeaGreen;
//input color fibUpColor=clrFireBrick;  // clrBrown

// #define NFL    15       // number of fibo levels, THE OLD LEVELS ARE NOT USED IN THIS VERSION!
#define NFL    4        // number of fib retracements
#define NMA    7        // number of MAs, change ma_period[NMA-1] accordingly 


int numBars[] = {1440, 864, 960, 960, 1200, 900, 500, 312, 144};  // choosen so that with every time frame the actual look back period is increased by a factor between 2-4. from 1 day to 12 years.
double fibRetracementLevels[] = {0.382, 0.5, 0.618, 1.};
string fibRetracementLevelsStr[] = {"38", "50", "62", "100"};

int      allTFP[9] = {1, 5, 15, 30, 60, 240, 1440, 10080, 43200};
double   fma[][NMA];        // [NTF][NMA]                   // mtf fibo MAs
double   fib_up[][NFL];    // [NTF][NFL]                   // fibo levels to the up side
double   fib_down[][NFL];  // [NTF][NFL]                   // fibo levels to the down side
double   bsl[NFL];                                          // fibo distances ('point' adjusted)
double   price, point;
double   tmpArray[NMA], lowestMA, highestMA;
// int      _fib[NFL]    = {10,16,26,42,68,111,179,290,470,760,1230,1989,3219,5208,8427};  // fibo distances : 10, 16, 26, 42, 68, 111, 179, 290, 470, 760
int      ma_period[7] = {21,34,55,75,100,144,233};          // SMAs, NMA-1
int      tfp[];  // [NTF]
int      bar, i;
int      tf, c, offset, xUnit;
int      shift, spacing, width, width2, Vwidth, BBshift, BBwidth, NTF, Width2, Shift, BBShift;
// color    Shade[NFL]    = {C'255,217,152', C'255,217,152', C'255,157,17', C'255,157,17', C'255,157,17', C'255,157,17', C'255,157,17', C'255,157,17', C'255,157,17', C'255,157,17', C'255,157,17', C'255,157,17', C'255,157,17', C'255,157,17', C'255,157,17'};
// color    Shade1[NFL]   = {C'196,255,255', C'196,255,255', C'25,139,255', C'25,139,255', C'25,139,255', C'25,139,255', C'25,139,255', C'25,139,255', C'25,139,255', C'25,139,255', C'25,139,255', C'25,139,255', C'25,139,255', C'25,139,255', C'25,139,255'};
color    Shade[NFL]    = {C'255,217,152', C'255,217,152', C'255,157,17', C'255,157,17'};
color    Shade1[NFL]   = {C'196,255,255', C'196,255,255', C'25,139,255', C'25,139,255'};
int      zoomState=-1;
color    col, macolor;
string   objName, MA, name;
string   uniqueid = "FXG: ";
datetime curTime;
double   pipPoints;

double Pointx;
double divider;
int x_digits;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
   if(!ChartSetInteger(0,CHART_HEIGHT_IN_PIXELS,0,50))
     {
      //--- display the error message in Experts journal
      Print(__FUNCTION__+", Error Code = ",GetLastError());
      return(false);
     }
   initializeArrays();
   xUnit   = Period() * 60;
   shift   = Shift * xUnit;
   spacing = Spacing * xUnit;
   width   = Width * xUnit;
   width2  = Width2 * xUnit;
   Vwidth  = VWidth * xUnit;

   BBshift   = BBShift * xUnit;
   BBwidth   = BBWidth * xUnit;
   
   point   = 0.01;
   if(Digits > 3) point = 0.0001;
   
   if(Digits==3 || Digits==5)
      {
      pipPoints=Point*10;
      }
   else
      {
      pipPoints=Point;
      }
//----------------------------------
   //Spread: Check for 3 & 5 digit
   if (Point == 0.00001) Pointx = 0.0001; //5 digits
   else if (Point == 0.001) Pointx = 0.01; //3 digits
   else Pointx = Point; //Normal
  
   if(Pointx > Point)
      {
      divider = 10.0;
      x_digits = 1;
      }
   else 
      {
      divider = 1;
      x_digits = 0;
      }
//----------------------------------

   ChartSetInteger(0,CHART_AUTOSCROLL,true);
   ChartSetInteger(0,CHART_SHIFT,false);
   ChartSetInteger(0,CHART_MODE,CHART_LINE);
   ChartSetInteger(0,CHART_SHOW_GRID,false); 
   ChartSetInteger(0,CHART_SHOW_OHLC,false);  
   ChartSetInteger(0,CHART_SHOW_ASK_LINE,false); 
   ChartSetInteger(0,CHART_SHOW_OBJECT_DESCR,false);     
   ChartSetInteger(0,CHART_SHOW_VOLUMES,CHART_VOLUME_HIDE);
   ChartSetInteger(0,CHART_FOREGROUND,false);   
         
   ChartSetInteger(0,CHART_COLOR_CHART_LINE,clrNONE);
   ChartSetInteger(0,CHART_COLOR_BACKGROUND,C'32,41,49');
   ChartSetInteger(0,CHART_COLOR_FOREGROUND,C'32,41,49');
   ChartSetInteger(0,CHART_COLOR_GRID,clrNONE);
   ChartSetInteger(0,CHART_COLOR_CANDLE_BULL,clrNONE);
   ChartSetInteger(0,CHART_COLOR_CANDLE_BEAR,clrNONE);      
   ChartSetInteger(0,CHART_COLOR_CHART_UP,clrNONE);
   ChartSetInteger(0,CHART_COLOR_CHART_DOWN,clrNONE);  
   ChartSetInteger(0,CHART_COLOR_VOLUME,clrGreen);  
   ChartSetInteger(0,CHART_COLOR_STOP_LEVEL,clrRed);  
            
   ChartSetInteger(0,CHART_SCALEFIX,true);
   ChartSetInteger(0,CHART_SHOW_DATE_SCALE,false);
   ChartSetDouble(0,CHART_FIXED_MAX,Bid+(Grid_Range*pipPoints));
   ChartSetDouble(0,CHART_FIXED_MIN,Bid-(Grid_Range*pipPoints));
   
   
//+------------------------------------------------------------------+
//| creating the objects for drawing the grid                        |
//+------------------------------------------------------------------+

   // for(i=0; i<NFL; i++)  bsl[i] = _fib[i]*point;
   for(tf=0; tf<NTF; tf++)
   {  
      
      for(i=0; i<NFL; i++)
      {  
         objName = uniqueid + "fib_up_bg_" + tf+"_"+i;            // upper fibo levels
         ObjectCreate(objName, OBJ_TEXT, 0, 0, 0, 0, 0);

         ObjectSetInteger(NULL,objName, OBJPROP_ANCHOR,ANCHOR_CENTER);
         ObjectSet(objName, OBJPROP_COLOR, clrBlack);
         ObjectSetInteger(NULL,objName,OBJPROP_FONTSIZE,7);
                     
         objName = uniqueid + "fib_down_bg_" + tf+"_"+i;          // lower fibo levels
         ObjectCreate(objName, OBJ_TEXT, 0, 0, 0, 0, 0);

         ObjectSetInteger(NULL,objName, OBJPROP_ANCHOR,ANCHOR_CENTER);
         ObjectSet(objName, OBJPROP_COLOR, clrBlack);
         ObjectSetInteger(NULL,objName,OBJPROP_FONTSIZE,7);
             
      }
      
      for(i=0; i<NMA; i++)
      {
         objName = uniqueid + "fib_MA_" + tf + "_" + i;       // MA levels
         ObjectCreate(objName, OBJ_TEXT, 0, 0, 0, 0, 0);

         ObjectSetInteger(NULL,objName, OBJPROP_ANCHOR,ANCHOR_CENTER);
         ObjectSet(objName, OBJPROP_COLOR, clrBlack);
         ObjectSetInteger(NULL,objName,OBJPROP_FONTSIZE,7);
      }
      
      for(i=0; i<NFL; i++)
      {  
                     
         objName = uniqueid+"fib_up_"+tf+"_"+i;            // upper fibo levels
         ObjectCreate(objName, OBJ_TEXT, 0, 0, 0, 0, 0);
         ObjectSetInteger(NULL,objName, OBJPROP_ANCHOR,ANCHOR_CENTER);
         ObjectSet(objName, OBJPROP_COLOR, Fib_price_color_high);  
             
         objName = uniqueid+"fib_down_"+tf+"_"+i;          // lower fibo levels
         ObjectCreate(objName, OBJ_TEXT, 0, 0, 0, 0, 0);
         ObjectSetInteger(NULL,objName, OBJPROP_ANCHOR,ANCHOR_CENTER);
         ObjectSet(objName, OBJPROP_COLOR, Fib_price_color_low);
      }
   }
   drawTimeFrameHeader();
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
{
   ObjectDelete("Bid");
  
   ObjectDelete(0,"Active_zone");
//-----------------------------      
   ObjectDelete(0,"up_20");
   ObjectDelete(0,"up_30");
   ObjectDelete(0,"up_40");
   ObjectDelete(0,"up_50");
   ObjectDelete(0,"up_60");
   ObjectDelete(0,"up_ext");
//-----------------------------
   ObjectDelete(0,"down_20");   
   ObjectDelete(0,"down_30");      
   ObjectDelete(0,"down_40");
   ObjectDelete(0,"down_50");
   ObjectDelete(0,"down_60");      
   ObjectDelete(0,"down_ext");
//-----------------------------
   for(tf=0; tf<NTF+1; tf++)
   {
      ObjectDelete(0,"vL_" + IntegerToString(tf));
   }
   objName=uniqueid+"TF_BG";
   ObjectDelete(NULL,objName);
   for (tf=0;tf<NTF;tf++)
   {   
      objName = uniqueid+"TF_"+tf;
      ObjectDelete(NULL,objName);
   }
   ObjectDelete("Daily_High_");   
   ObjectDelete("Daily_Low_");    
   ObjectDelete("Daily_High");   
   ObjectDelete("Daily_Low");
   
   ObjectDelete("Price_1");
   
   ObjectDelete("Weekly_High_");   
   ObjectDelete("Weekly_Low_");    
   ObjectDelete("Weekly_High");   
   ObjectDelete("Weekly_Low"); 

   ObjectDelete("Monthly_High_");   
   ObjectDelete("Monthly_Low_");    
   ObjectDelete("Monthly_High");   
   ObjectDelete("Monthly_Low"); 
   
   ObjectDelete("X_Daily_High_");   
   ObjectDelete("X_Daily_Low_");    
   ObjectDelete("X_Daily_High");   
   ObjectDelete("X_Daily_Low");
   
   ObjectDelete("Support_pivot_simple-3");
   ObjectDelete("Support_pivot_simple-2");
   ObjectDelete("Support_pivot_simple-1");
   ObjectDelete("Resistance_pivot_simple-1");
   ObjectDelete("Resistance_pivot_simple-2");
   ObjectDelete("Resistance_pivot_simple-3");
   
   ObjectDelete("Support-3_week");
   ObjectDelete("Support-2_week");
   ObjectDelete("Support-1_week");
   ObjectDelete("Resistance-1_week");
   ObjectDelete("Resistance-2_week");
   ObjectDelete("Resistance-3_week");
   
   ObjectDelete("Support-3_monthly");
   ObjectDelete("Support-2_monthly");
   ObjectDelete("Support-1_monthly");
   ObjectDelete("Resistance-1_monthly");
   ObjectDelete("Resistance-2_monthly");
   ObjectDelete("Resistance-3_monthly");

   ObjectDelete("Daily_Open_");   
   ObjectDelete("Daily_Open");    

   ObjectDelete("D1Range");   
   ObjectDelete("D1Change");       

   ObjectDelete(0,"MA_21");      
   ObjectDelete(0,"SMA_21_DIS");
   ObjectDelete(0,"BBHigh_Area_0");
   ObjectDelete(0,"BBLow_Area_0");
   ObjectDelete(0,"BBHigh_Area");
   ObjectDelete(0,"BBLow_Area");
         
   string lookFor       = uniqueid;
   int    lookForLength = StringLen(lookFor);   
   for(int x = ObjectsTotal() - 1; x >= 0; x--)
   {
      string xname = ObjectName(x);
         if(StringSubstr(xname, 0, lookForLength) == lookFor) ObjectDelete(xname);
   }
   return(0);
}


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{  
   point   = 0.01;
   if(Digits > 3) point = 0.0001;
   
   ChartSetInteger(0,CHART_SCALEFIX,true);
   ChartSetInteger(0,CHART_SHOW_DATE_SCALE,false);
   ChartSetDouble(0,CHART_FIXED_MAX,Bid+(Grid_Range*pipPoints));
   ChartSetDouble(0,CHART_FIXED_MIN,Bid-(Grid_Range*pipPoints));
     
   ObjectDelete("Bid");
   ObjectCreate(0,"Bid",OBJ_TREND,0,0,Bid);
   ObjectSet("Bid",OBJPROP_TIME1,curTime+shift);
   ObjectSet("Bid",OBJPROP_TIME2,curTime+shift+width2);
   ObjectSet("Bid",OBJPROP_PRICE1, Bid);
   ObjectSet("Bid",OBJPROP_PRICE2, Bid);
   ObjectSet("Bid",OBJPROP_STYLE,0);
   ObjectSet("Bid",OBJPROP_WIDTH,2);
   ObjectSet("Bid",OBJPROP_COLOR,C'255,226,64');
   ObjectSet("Bid",OBJPROP_SELECTABLE,false);
   ObjectSet("Bid",OBJPROP_BACK,true);
   ObjectSet("Bid",OBJPROP_RAY, false);
   
   if (Show_bid==true) 
   
   ObjectDelete("Price_1");
   ObjectCreate(0,"Price_1",OBJ_HLINE,0,0,Bid);
   ObjectSet("Price_1",OBJPROP_STYLE,5);
   ObjectSet("Price_1",OBJPROP_COLOR, C'255,226,64');
   
   //ObjectCreate(0,"Bid",OBJ_HLINE,0,0,Bid);
   //ObjectSet("Bid",OBJPROP_STYLE,5);
   //ObjectSet("Bid",OBJPROP_COLOR,clrGold);
   //ObjectSet("Bid",OBJPROP_SELECTABLE,false);   
   
//+------------------------------------------------------------------+
//| Time lines                                                       |
//+------------------------------------------------------------------+

   curTime = Time[0]; 
   price   = Bid;
    
   for(tf=0; tf<NTF; tf++)
   {
      bar = iBarShift(NULL, tfp[tf], curTime, false);
      for(i=0; i<NMA; i++)  fma[tf][i] = iMA(NULL, tfp[tf], ma_period[i], 0, MA_mode, PRICE_CLOSE, bar/Period());  // populating the array...
      for(i=0; i<NMA; i++) tmpArray[i] = fma[tf][i];                                                               // finding the highest and lowest MAs from the (7) fma's/MA's
      ArraySort(tmpArray);                                                                                         // copying the MAs levels of this TF to one dim array to feed ArrayBsearch
      lowestMA  = tmpArray[0];
      highestMA = tmpArray[6];

      //for(i=0; i<NFL; i++)                                                                                         // populating the bsl arrays...
      //{
      //   fib_up[tf][i]   = lowestMA  + bsl[i];
      //   fib_down[tf][i] = highestMA - bsl[i];
      //}
      
      // real fib retracements:
      int lastSize, lowestMinIndex = 0, highestMaxIdex = 0;
      double low, high, lowestMin = 1.e9, highestMax = 0., minAfterHighestMax = 1.e9, maxAfterLowestMin = 0.;
      int localMinIndices[], localMaxIndices[];
      double localMin[], localMax[]; 
      ArrayResize(localMin, 0);
      ArrayResize(localMinIndices, 0);
      ArrayResize(localMax, 0);
      ArrayResize(localMaxIndices, 0);
      for(i=2; i<numBars[tf]-2; i++) {
         low = iLow(NULL, tfp[tf], i);
         if (low < iLow(NULL, tfp[tf], i-2) && low < iLow(NULL, tfp[tf], i-1) && low < iLow(NULL, tfp[tf], i+1) && low < iLow(NULL, tfp[tf], i+2)) {
            lastSize = ArraySize(localMin);
            ArrayResize(localMin, lastSize+1);
            ArrayResize(localMinIndices, lastSize+1);
            localMin[lastSize] = low;
            localMinIndices[lastSize] = i;
         }
         high = iHigh(NULL, tfp[tf], i);
          if (high > iHigh(NULL, tfp[tf], i-2) && high > iHigh(NULL, tfp[tf], i-1) && high > iHigh(NULL, tfp[tf], i+1) && high > iHigh(NULL, tfp[tf], i+2)) {
            lastSize = ArraySize(localMax);
            ArrayResize(localMax, lastSize+1);
            ArrayResize(localMaxIndices, lastSize+1);
            localMax[lastSize] = high;
            localMaxIndices[lastSize] = i;
         }
      };
      for(i=0; i<ArraySize(localMin); i++) if (localMin[i] < lowestMin) {
         lowestMin = localMin[i];
         lowestMinIndex = localMinIndices[i];
      }
      for(i=0; i<ArraySize(localMax); i++) if (localMax[i] > highestMax) {
         highestMax = localMax[i];
         highestMaxIdex = localMaxIndices[i];
      }
      
      // start and end of for loop might be different if we load bars as array. is that possible in mql?
      for(i=0; i<lowestMinIndex; i++) if (iHigh(NULL, tfp[tf], i) > maxAfterLowestMin) maxAfterLowestMin = iHigh(NULL, tfp[tf], i);
      for(i=0; i<highestMaxIdex; i++) if (iLow(NULL, tfp[tf], i) < minAfterHighestMax) minAfterHighestMax = iLow(NULL, tfp[tf], i);
      // for debugging:
      // Print(tfp[tf], "  |  ", lowestMinIndex, "  |  ", highestMaxIdex, "  |  ", lowestMin, "  |  ", highestMax, "  |  ", minAfterHighestMax, "  |  ", maxAfterLowestMin);
      // Print(TimeToStr(iTime(NULL, tfp[tf], lowestMinIndex)), "  |  ", TimeToStr(iTime(NULL, tfp[tf], highestMaxIdex)));
      for(i=0; i<NFL; i++) {
         if (maxAfterLowestMin < lowestMin || highestMaxIdex < 5) fib_up[tf][i] = 0;
         else fib_up[tf][i] = maxAfterLowestMin - fibRetracementLevels[i] * (maxAfterLowestMin - lowestMin);
         if (highestMax < minAfterHighestMax || lowestMinIndex < 5) fib_down[tf][i] = 0;
         else fib_down[tf][i] = minAfterHighestMax + fibRetracementLevels[i] * (highestMax - minAfterHighestMax);
         
      }
   }
//+------------------------------------------------------------------+
//| drawing the DFG levels from top to bottom                        |
//+------------------------------------------------------------------+
    
   for(tf=0; tf<NTF; tf++) 
   {  
   
      offset = 0;                                                                
      // for(i=offset; i<NFL-1; i++) if(fib_up[tf][i] <= fib_down[tf][i]) offset++;
        
      double highest=0;
      // for(i=NFL-2; i>=offset; i--)
      for(i=NFL; i>=offset; i--)
      {                
         if (fib_down[tf][i]>highest) highest=fib_up[tf][i+1];
         
         if (Fib_Box==true)
         {
         objName = uniqueid+"fib_up_bg_"+tf+"_"+(i-offset);
         
         //ObjectDelete(NULL,objName);
         //ObjectCreate(objName, OBJ_TEXT, 0, 0, 0, 0, 0);
         
         ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+12*xUnit);
         ObjectSet(objName, OBJPROP_PRICE1, fib_up[tf][i]);
         
          if (i<=15 && i>=0){
            //if (fib_up[tf][i]>=price) ObjectSet(objName, OBJPROP_COLOR,Shade[i]);
            //   else 
            ObjectSet(objName, OBJPROP_COLOR,Shade1[i]);  // buy always bluish
            
            ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,9);
            ObjectSetString(NULL,objName, OBJPROP_FONT, "Webdings");
            ObjectSetInteger(NULL,objName,OBJPROP_ANCHOR,ANCHOR_CENTER);
            ObjectSetText(objName,"gg");
            }
         }
                 
         //if (fib_up[tf][i]>=price) ObjectSet(objName, OBJPROP_COLOR,C'255,157,17');
            //else 
               //ObjectSet(objName, OBJPROP_COLOR,C'25,139,255');
         
            
         objName = uniqueid+"fib_up_"+tf+"_"+(i-offset);
         ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+12*xUnit);
         ObjectSet(objName, OBJPROP_PRICE1, fib_up[tf][i]);
         ObjectSetInteger(0,objName,OBJPROP_ANCHOR,ANCHOR_CENTER);
         ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,8);
         ObjectSetString(NULL,objName, OBJPROP_FONT, "Century Gothic");
         
         string upper = DoubleToString(fib_up[tf][i],Digits);
         int SLength = StringLen(upper);
         string upperL = StringSubstr(upper, SLength-3, 2);
         
         ObjectSetText(objName,  "-" + fibRetracementLevelsStr[i] + "-");            
      }

      double lowest=9999.9999;
      // for(i=0; i<NFL-1; i++)
      for(i=0; i<NFL; i++)
      {         
         if(fib_down[tf][i]<lowest) lowest=fib_down[tf][i+1];
         
         if (Fib_Box==true)
         {
         objName = uniqueid+"fib_down_bg_"+tf+"_"+(i-offset);
         
         //ObjectDelete(NULL,objName);
         //ObjectCreate(objName, OBJ_TEXT, 0, 0, 0, 0, 0);
         
         ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+12*xUnit);
         ObjectSet(objName, OBJPROP_PRICE1, fib_down[tf][i]);
         
         if (i<=15 && i>=0){
            // if (fib_down[tf][i]<=price) ObjectSet(objName, OBJPROP_COLOR,Shade1[i]);
            //   else 
            ObjectSet(objName, OBJPROP_COLOR,Shade[i]);  // sell always reddish
         
            ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,9);
            ObjectSetString(NULL,objName, OBJPROP_FONT, "Webdings");
            ObjectSetInteger(NULL,objName,OBJPROP_ANCHOR,ANCHOR_CENTER);
            ObjectSetText(objName,"gg");
         }
         }         
         //if (fib_down[tf][i]<=price) ObjectSet(objName, OBJPROP_COLOR,C'25,139,255');
            //else 
               //ObjectSet(objName, OBJPROP_COLOR,C'255,157,17');
            
            objName = uniqueid+"fib_down_"+tf+"_"+(i-offset);
            ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+12*xUnit);
            ObjectSet(objName, OBJPROP_PRICE1, fib_down[tf][i]);
            ObjectSetInteger(0,objName,OBJPROP_ANCHOR,ANCHOR_CENTER);
            ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,8);
            ObjectSetString(NULL,objName, OBJPROP_FONT, "Century Gothic");
            
            string lower = DoubleToString(fib_down[tf][i],Digits);
            int SLength2 = StringLen(lower);
            string lowerL = StringSubstr(lower, SLength2-3, 2);

            ObjectSetText(objName,  "-"+ fibRetracementLevelsStr[i] + "-");
      }

//+------------------------------------------------------------------+
//| drawing the MA levels and arrows                                 |
//+------------------------------------------------------------------+

      for(i=0; i<NMA; i++)
      if (Diamond_Direction==true)
      {
      {
         objName = uniqueid + "fib_MA_" + tf + "_" + i;
            ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+10*xUnit);
            ObjectSet(objName, OBJPROP_PRICE1, fma[tf][i]);

         double xMA = iMA(NULL, tfp[tf], ma_period[i], 0, MA_mode, PRICE_CLOSE, 1);            
         
         if(i==0){         
                          if (fma[tf][i]>=price) ObjectSet(objName, OBJPROP_COLOR,DiamondWeakDirection1);
                           else 
                              ObjectSet(objName, OBJPROP_COLOR,DiamondWeakDirection0);
                              
                              ObjectSetInteger(NULL,objName,OBJPROP_ANCHOR,ANCHOR_CENTER);
                              ObjectSetString(NULL,objName, OBJPROP_FONT, "Wingdings");
                              ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,13);
                              if(fma[tf][i] > xMA){ObjectSetText(objName,"u"); ObjectSet(objName, OBJPROP_PRICE1, (fma[tf][i])+3*Point); ObjectSet(objName,OBJPROP_ANGLE,0);}
                              if(fma[tf][i] < xMA){ObjectSetText(objName,"u"); ObjectSet(objName, OBJPROP_PRICE1, (fma[tf][i])-5*Point); ObjectSet(objName,OBJPROP_ANGLE,0);}
                              ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+10*xUnit);
                              
                 }        
         if(i==1){         
                          if (fma[tf][i]>=price) ObjectSet(objName, OBJPROP_COLOR,DiamondDirectionWeakAverage1);
                           else 
                              ObjectSet(objName, OBJPROP_COLOR,DiamondDirectionWeakAverage0);
                              
                              ObjectSetInteger(NULL,objName,OBJPROP_ANCHOR,ANCHOR_CENTER);
                              ObjectSetString(NULL,objName, OBJPROP_FONT, "Wingdings");
                              ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,13);
                              if(fma[tf][i] > xMA){ObjectSetText(objName,"u"); ObjectSet(objName, OBJPROP_PRICE1, (fma[tf][i])+3*Point); ObjectSet(objName,OBJPROP_ANGLE,0);}
                              if(fma[tf][i] < xMA){ObjectSetText(objName,"u"); ObjectSet(objName, OBJPROP_PRICE1, (fma[tf][i])-5*Point); ObjectSet(objName,OBJPROP_ANGLE,0);}
                              ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+10*xUnit);
                 }
         if(i==6){
                     
                               if (fma[tf][i]>=price) ObjectSet(objName, OBJPROP_COLOR,DiamondDirectionStrong1);
                                 else 
                                    ObjectSet(objName, OBJPROP_COLOR,DiamondDirectionStrong0);
                        
                                    ObjectSetInteger(NULL,objName,OBJPROP_ANCHOR,ANCHOR_CENTER);
                                    ObjectSetString(NULL,objName, OBJPROP_FONT, "Wingdings");
                                    ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,14);
                                    if(fma[tf][i] > xMA){ObjectSetText(objName,"u"); ObjectSet(objName, OBJPROP_PRICE1, (fma[tf][i])+3*Point); ObjectSet(objName,OBJPROP_ANGLE,0);}
                                    if(fma[tf][i] < xMA){ObjectSetText(objName,"u"); ObjectSet(objName, OBJPROP_PRICE1, (fma[tf][i])-5*Point); ObjectSet(objName,OBJPROP_ANGLE,0);}
                                    ObjectSet(objName, OBJPROP_TIME1,  curTime+shift+tf*spacing+10*xUnit);
            

                 }      
         if (i<6 && i>1){
         
                              if (fma[tf][i]>=price) ObjectSet(objName, OBJPROP_COLOR,DiamondDirectionStrongAverage1);
                                 else 
                                    ObjectSet(objName, OBJPROP_COLOR,DiamondDirectionStrongAverage0);
                                    
                                    ObjectSetInteger(NULL,objName,OBJPROP_ANCHOR,ANCHOR_CENTER);
                                    ObjectSetString(NULL,objName, OBJPROP_FONT, "Wingdings");
                                    ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,11);
                                    ObjectSetText(objName,"u");
            
                }
                
     }
     } 
   }
 
//+------------------------------------------------------------------+
//| drawing the Red/Green Matrix                                     |
//+------------------------------------------------------------------+

   double  SMA_21 = iMA(0,PERIOD_M1,21,0,MODE_SMA,PRICE_CLOSE,0);
   
   double r1 = SMA_21+(20*pipPoints); 
   double r2 = SMA_21+(30*pipPoints); 
   double r3 = SMA_21+(40*pipPoints); 
   double r4 = SMA_21+(50*pipPoints); 
   double r5 = SMA_21+(60*pipPoints); 
   double r6 = SMA_21+(70*pipPoints); 

   double s1 = SMA_21-(20*pipPoints); 
   double s2 = SMA_21-(30*pipPoints); 
   double s3 = SMA_21-(40*pipPoints); 
   double s4 = SMA_21-(50*pipPoints); 
   double s5 = SMA_21-(60*pipPoints); 
   double s6 = SMA_21-(70*pipPoints); 
    
//-----------------------------------
      
   curTime = Time[0];  
     
//-------------------------------------------------------------
      ObjectDelete(0,"Active_zone");
   ObjectCreate(0,"Active_zone",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("Active_zone", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("Active_zone", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("Active_zone", OBJPROP_PRICE1, r1 );
   ObjectSet("Active_zone", OBJPROP_PRICE2, s1 );
   ObjectSet("Active_zone", OBJPROP_COLOR,  neutral_col);
//-------------------------------------------------------------
   
      ObjectDelete(0,"up_20");
   ObjectCreate(0,"up_20",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("up_20", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("up_20", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("up_20", OBJPROP_PRICE1, r1 );
   ObjectSet("up_20", OBJPROP_PRICE2, r2 );
   ObjectSet("up_20", OBJPROP_COLOR,  up_col_1);
   
      ObjectDelete(0,"up_30");
   ObjectCreate(0,"up_30",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("up_30", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("up_30", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("up_30", OBJPROP_PRICE1, r2 );
   ObjectSet("up_30", OBJPROP_PRICE2, r3 );
   ObjectSet("up_30", OBJPROP_COLOR, up_col_2);
      
      ObjectDelete(0,"up_40");
   ObjectCreate(0,"up_40",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("up_40", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("up_40", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("up_40", OBJPROP_PRICE1, r3 );
   ObjectSet("up_40", OBJPROP_PRICE2, r4 );
   ObjectSet("up_40", OBJPROP_COLOR, up_col_3);

      ObjectDelete(0,"up_50");
   ObjectCreate(0,"up_50",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("up_50", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("up_50", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("up_50", OBJPROP_PRICE1, r4 );
   ObjectSet("up_50", OBJPROP_PRICE2, r5 );
   ObjectSet("up_50", OBJPROP_COLOR, up_col_4);

      ObjectDelete(0,"up_60");
   ObjectCreate(0,"up_60",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("up_60", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("up_60", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("up_60", OBJPROP_PRICE1, r5 );
   ObjectSet("up_60", OBJPROP_PRICE2, r6 );
   ObjectSet("up_60", OBJPROP_COLOR, up_col_5);
      
      ObjectDelete(0,"up_ext");
   ObjectCreate(0,"up_ext",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("up_ext", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("up_ext", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("up_ext", OBJPROP_PRICE1, r6 );
   ObjectSet("up_ext", OBJPROP_PRICE2, WindowPriceMax() );
   ObjectSet("up_ext", OBJPROP_COLOR, up_col_6);
         
//--------------------------------------------------------------------------------
//--------------------------------------------------------------------------------
   
      ObjectDelete(0,"down_20");
   ObjectCreate(0,"down_20",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("down_20", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("down_20", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("down_20", OBJPROP_PRICE1, s1 );
   ObjectSet("down_20", OBJPROP_PRICE2, s2 );
   ObjectSet("down_20", OBJPROP_COLOR, down_col_1);
   
      ObjectDelete(0,"down_30");
   ObjectCreate(0,"down_30",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("down_30", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("down_30", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("down_30", OBJPROP_PRICE1, s2 );
   ObjectSet("down_30", OBJPROP_PRICE2, s3 );
   ObjectSet("down_30", OBJPROP_COLOR, down_col_2);
      
      ObjectDelete(0,"down_40");
   ObjectCreate(0,"down_40",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("down_40", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("down_40", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("down_40", OBJPROP_PRICE1, s3 );
   ObjectSet("down_40", OBJPROP_PRICE2, s4 );
   ObjectSet("down_40", OBJPROP_COLOR, down_col_3);

      ObjectDelete(0,"down_50");
   ObjectCreate(0,"down_50",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("down_50", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("down_50", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("down_50", OBJPROP_PRICE1, s4 );
   ObjectSet("down_50", OBJPROP_PRICE2, s5 );
   ObjectSet("down_50", OBJPROP_COLOR, down_col_4);  

      ObjectDelete(0,"down_60");
   ObjectCreate(0,"down_60",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("down_60", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("down_60", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("down_60", OBJPROP_PRICE1, s5 );
   ObjectSet("down_60", OBJPROP_PRICE2, s6 );
   ObjectSet("down_60", OBJPROP_COLOR, down_col_5);
      
      ObjectDelete(0,"down_ext");
   ObjectCreate(0,"down_ext",OBJ_RECTANGLE,0,0,0,0,0);
   ObjectSet("down_ext", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("down_ext", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("down_ext", OBJPROP_PRICE1, s6 );
   ObjectSet("down_ext", OBJPROP_PRICE2, WindowPriceMin() );
   ObjectSet("down_ext", OBJPROP_COLOR, down_col_6);
            
//-------------------------------------------------------------------------------

      for(tf=0; tf<NTF+1; tf++)
   {
      ObjectDelete(0,"vL_" + IntegerToString(tf));
      ObjectCreate(0,"vL_" + IntegerToString(tf),OBJ_VLINE,0,0,0,0,0);
      ObjectSet("vL_" + IntegerToString(tf), OBJPROP_TIME1,  curTime+shift + tf * Vwidth);
      ObjectSet("vL_" + IntegerToString(tf), OBJPROP_COLOR,  LineColor);
      ObjectSet("vL_" + IntegerToString(tf), OBJPROP_BACK,  false);
      ObjectSet("vL_" + IntegerToString(tf), OBJPROP_WIDTH, 2);
      ObjectSet("vL_" + IntegerToString(tf), OBJPROP_STYLE, STYLE_SOLID);
   }
   
//--------------------------------------------------------------------
//   Daily high/low

   double D1_high=iHigh(NULL, PERIOD_D1,0); 
   double D1_low=iLow(NULL, PERIOD_D1,0);
   double D1_close=iClose(NULL, PERIOD_D1,0);
   double W1_high=iHigh(NULL, PERIOD_W1,0); 
   double W1_low=iLow(NULL, PERIOD_W1,0);
   double W1_close=iClose(NULL, PERIOD_W1,0);
   double MN1_high=iHigh(NULL, PERIOD_MN1,0); 
   double MN1_low=iLow(NULL, PERIOD_MN1,0);
   double MN1_close=iClose(NULL, PERIOD_MN1,0);      
   
 if (D1_Show_Line==true) 
   { 
   ObjectDelete("Daily_High_");
   ObjectCreate(0,"Daily_High_",OBJ_TREND,0,0,0,0);
   ObjectSet("Daily_High_", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("Daily_High_", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("Daily_High_", OBJPROP_PRICE1, D1_high);
   ObjectSet("Daily_High_", OBJPROP_PRICE2, D1_high);
   ObjectSet("Daily_High_",OBJPROP_STYLE, D1_style);
   ObjectSet("Daily_High_",OBJPROP_COLOR, D1_Highcol);
   ObjectSet("Daily_High_",OBJPROP_RAY,false);
   
   ObjectDelete("Daily_Low_");
   ObjectCreate(0,"Daily_Low_",OBJ_TREND,0,0,0,0);
   ObjectSet("Daily_Low_", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("Daily_Low_", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("Daily_Low_", OBJPROP_PRICE1, D1_low);
   ObjectSet("Daily_Low_", OBJPROP_PRICE2, D1_low);
   ObjectSet("Daily_Low_",OBJPROP_STYLE, D1_style);
   ObjectSet("Daily_Low_",OBJPROP_COLOR, D1_Lowcol);
   ObjectSet("Daily_Low_",OBJPROP_RAY,false);
   }
   
 if (D1_Show_Price==true) 
   { 
   ObjectDelete("Daily_High");
   ObjectCreate(0,"Daily_High",OBJ_HLINE,0,0,D1_high);
   ObjectSet("Daily_High",OBJPROP_STYLE,5);
   ObjectSet("Daily_High",OBJPROP_COLOR, D1_Highcol);
   
   ObjectDelete("Daily_Low");
   ObjectCreate(0,"Daily_Low",OBJ_HLINE,0,0,D1_low);
   ObjectSet("Daily_Low",OBJPROP_STYLE,5);
   ObjectSet("Daily_Low",OBJPROP_COLOR, D1_Lowcol);
   }
   
//--------------------------------------------------------------------
// Pivot Simples

 if (show_Fibo_Point==true)
   {     
   double R3,R2,R1,Pivot,S1,S2,S3;  

   Pivot=(D1_high+D1_low+D1_close)/3;
   
   R3=Pivot+(R2-S2);
   R2=Pivot+(R1-S1);
   R1=(2*Pivot)-D1_low;

   S1=(2*Pivot)-D1_high;
   S2=Pivot-(R1-S1);
   S3=Pivot-(R2-S2); 
   
   //---------------------------------------------------------
   
   objName=uniqueid+"R3";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],R3,Time[0],R3);
   ObjectSet(objName, OBJPROP_TIME1,  curTime+shift);
   ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet(objName, OBJPROP_STYLE, 2); 
   ObjectSet(objName, OBJPROP_COLOR, fibPoints_R_Color);
   ObjectSet(objName, OBJPROP_BACK,true);
   ObjectSet(objName, OBJPROP_SELECTABLE, false);
   ObjectSet(objName, OBJPROP_RAY, false);
      
   //---------------------------------------------------------
   
   objName=uniqueid+"R2";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],R2,Time[0],R2);
   ObjectSet(objName, OBJPROP_TIME1,  curTime+shift);
   ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet(objName, OBJPROP_STYLE,2);
   ObjectSet(objName, OBJPROP_COLOR,fibPoints_R_Color);
   ObjectSet(objName, OBJPROP_BACK,true);
   ObjectSet(objName, OBJPROP_SELECTABLE,false);
   ObjectSet(objName, OBJPROP_RAY, false);
   
 
   //---------------------------------------------------------
   
   objName=uniqueid+"R1";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],R1,Time[0],R1);
   ObjectSet(objName, OBJPROP_TIME1,  curTime+shift);
   ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet(objName, OBJPROP_STYLE,2);
   ObjectSet(objName, OBJPROP_COLOR,fibPoints_R_Color);
   ObjectSet(objName, OBJPROP_BACK,true);
   ObjectSet(objName, OBJPROP_SELECTABLE,false);
   ObjectSet(objName, OBJPROP_RAY, false);
    
   
   //---------------------------------------------------------
   
   objName=uniqueid+"S3";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],S3,Time[0],S3);
   ObjectSet(objName, OBJPROP_TIME1,  curTime+shift);
   ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet(objName, OBJPROP_STYLE,2); 
   ObjectSet(objName, OBJPROP_COLOR,fibPoints_S_Color);
   ObjectSet(objName, OBJPROP_BACK,true);
   ObjectSet(objName, OBJPROP_SELECTABLE,false);
   ObjectSet(objName, OBJPROP_RAY, false);
   
   
   //---------------------------------------------------------
   
   objName=uniqueid+"S2";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],S2,Time[0],S2);
   ObjectSet(objName, OBJPROP_TIME1,  curTime+shift);
   ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet(objName, OBJPROP_STYLE,2); 
   ObjectSet(objName, OBJPROP_COLOR,fibPoints_S_Color);
   ObjectSet(objName, OBJPROP_BACK,true);
   ObjectSet(objName, OBJPROP_SELECTABLE,false);
   ObjectSet(objName, OBJPROP_RAY, false);
   
   
   //---------------------------------------------------------
   
   objName=uniqueid+"S1";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],S1,Time[0],S1);
   ObjectSet(objName, OBJPROP_TIME1,  curTime+shift);
   ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet(objName, OBJPROP_STYLE,2); 
   ObjectSet(objName, OBJPROP_COLOR,fibPoints_S_Color);
   ObjectSet(objName, OBJPROP_BACK,true);
   ObjectSet(objName, OBJPROP_SELECTABLE,false);
   ObjectSet(objName, OBJPROP_RAY, false);
   
   }
  if (show_Fibo_Point_Price==true) 
   { 
   ObjectDelete("Resistance_pivot_simple-3");
   ObjectCreate(0,"Resistance_pivot_simple-3",OBJ_HLINE,0,0,R3);
   ObjectSet("Resistance_pivot_simple-3",OBJPROP_STYLE,5);
   ObjectSet("Resistance_pivot_simple-3",OBJPROP_COLOR,fibPoints_R_Color);
   ObjectSet("Resistance_pivot_simple-3", OBJPROP_SELECTABLE, false);
   
   ObjectDelete("Resistance_pivot_simple-2");
   ObjectCreate(0,"Resistance_pivot_simple-2",OBJ_HLINE,0,0,R2);
   ObjectSet("Resistance_pivot_simple-2",OBJPROP_STYLE,5);
   ObjectSet("Resistance_pivot_simple-2",OBJPROP_COLOR,fibPoints_R_Color);
   ObjectSet("Resistance_pivot_simple-2", OBJPROP_SELECTABLE, false);
   
   ObjectDelete("Resistance_pivot_simple-1");
   ObjectCreate(0,"Resistance_pivot_simple-1",OBJ_HLINE,0,0,R1);
   ObjectSet("Resistance_pivot_simple-1",OBJPROP_STYLE,5);
   ObjectSet("Resistance_pivot_simple-1",OBJPROP_COLOR,fibPoints_R_Color);
   ObjectSet("Resistance_pivot_simple-1", OBJPROP_SELECTABLE, false);
   
   ObjectDelete("Support_pivot_simple-1");
   ObjectCreate(0,"Support_pivot_simple-1",OBJ_HLINE,0,0,S1);
   ObjectSet("Support_pivot_simple-1",OBJPROP_STYLE,5);
   ObjectSet("Support_pivot_simple-1",OBJPROP_COLOR,fibPoints_S_Color);
   ObjectSet("Support_pivot_simple-1", OBJPROP_SELECTABLE, false);
   
   ObjectDelete("Support_pivot_simple-2");
   ObjectCreate(0,"Support_pivot_simple-2",OBJ_HLINE,0,0,S2);
   ObjectSet("Support_pivot_simple-2",OBJPROP_STYLE,5);
   ObjectSet("Support_pivot_simple-2",OBJPROP_COLOR,fibPoints_S_Color);
   ObjectSet("Support_pivot_simple-2", OBJPROP_SELECTABLE, false);
   
   ObjectDelete("Support_pivot_simple-3");
   ObjectCreate(0,"Support_pivot_simple-3",OBJ_HLINE,0,0,S3);
   ObjectSet("Support_pivot_simple-3",OBJPROP_STYLE,5);
   ObjectSet("Support_pivot_simple-3",OBJPROP_COLOR,fibPoints_S_Color);
   ObjectSet("Support_pivot_simple-3", OBJPROP_SELECTABLE, false);
   
   }
//-----------------------------------------------------------
// Pivot Fibonacci Semanal

 if (show_Fibo_Point_Week==true)
   {     
   double R3S,R2S,R1S,PivotS,S1S,S2S,S3S;  

   PivotS=(W1_high+W1_low+W1_close)/3;
   
   R3S=PivotS+(W1_high-W1_low)*1.000;
   R2S=PivotS+(W1_high-W1_low)*0.618;
   R1S=PivotS+(W1_high-W1_low)*0.382;

   S1S=PivotS-(W1_high-W1_low)*0.382;
   S2S=PivotS-(W1_high-W1_low)*0.618;
   S3S=PivotS-(W1_high-W1_low)*1.000; 
   
   //---------------------------------------------------------
   
   objName=uniqueid+"R3S";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],R3S,Time[0],R3S);
   ObjectSet(objName, OBJPROP_TIME1,  curTime+shift);
   ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet(objName, OBJPROP_STYLE, 2); 
   ObjectSet(objName, OBJPROP_COLOR, fibPoints_R_Color_Week);
   ObjectSet(objName, OBJPROP_BACK,true);
   ObjectSet(objName, OBJPROP_SELECTABLE, false);
   ObjectSet(objName, OBJPROP_RAY, false);
      
   //---------------------------------------------------------
   
   objName=uniqueid+"R2S";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],R2S,Time[0],R2S);
   ObjectSet(objName, OBJPROP_TIME1,  curTime+shift);
   ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet(objName, OBJPROP_STYLE,2);
   ObjectSet(objName, OBJPROP_COLOR,fibPoints_R_Color_Week);
   ObjectSet(objName, OBJPROP_BACK,true);
   ObjectSet(objName, OBJPROP_SELECTABLE,false);
   ObjectSet(objName, OBJPROP_RAY, false);
   
 
   //---------------------------------------------------------
   
   objName=uniqueid+"R1S";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],R1S,Time[0],R1S);
   ObjectSet(objName, OBJPROP_TIME1,  curTime+shift);
   ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet(objName, OBJPROP_STYLE,2);
   ObjectSet(objName, OBJPROP_COLOR,fibPoints_R_Color_Week);
   ObjectSet(objName, OBJPROP_BACK,true);
   ObjectSet(objName, OBJPROP_SELECTABLE,false);
   ObjectSet(objName, OBJPROP_RAY, false);
    
   
   //---------------------------------------------------------
   
   objName=uniqueid+"S3S";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],S3S,Time[0],S3S);
   ObjectSet(objName, OBJPROP_TIME1,  curTime+shift);
   ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet(objName, OBJPROP_STYLE,2); 
   ObjectSet(objName, OBJPROP_COLOR,fibPoints_S_Color_Week);
   ObjectSet(objName, OBJPROP_BACK,true);
   ObjectSet(objName, OBJPROP_SELECTABLE,false);
   ObjectSet(objName, OBJPROP_RAY, false);
   
   
   //---------------------------------------------------------
   
   objName=uniqueid+"S2S";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],S2S,Time[0],S2S);
   ObjectSet(objName, OBJPROP_TIME1,  curTime+shift);
   ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet(objName, OBJPROP_STYLE,2); 
   ObjectSet(objName, OBJPROP_COLOR,fibPoints_S_Color_Week);
   ObjectSet(objName, OBJPROP_BACK,true);
   ObjectSet(objName, OBJPROP_SELECTABLE,false);
   ObjectSet(objName, OBJPROP_RAY, false);
   
   
   //---------------------------------------------------------
   
   objName=uniqueid+"S1S";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],S1S,Time[0],S1S);
   ObjectSet(objName, OBJPROP_TIME1,  curTime+shift);
   ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet(objName, OBJPROP_STYLE,2); 
   ObjectSet(objName, OBJPROP_COLOR,fibPoints_S_Color_Week);
   ObjectSet(objName, OBJPROP_BACK,true);
   ObjectSet(objName, OBJPROP_SELECTABLE,false);
   ObjectSet(objName, OBJPROP_RAY, false);
   
   }
  if (show_Fibo_Point_Price_Week==true) 
   { 
   ObjectDelete("Resistance-3_week");
   ObjectCreate(0,"Resistance-3_week",OBJ_HLINE,0,0,R3S);
   ObjectSet("Resistance-3_week",OBJPROP_STYLE,5);
   ObjectSet("Resistance-3_week",OBJPROP_COLOR,fibPoints_R_Color_Week);
   ObjectSet("Resistance-3_week", OBJPROP_SELECTABLE, false);
   
   ObjectDelete("Resistance-2_week");
   ObjectCreate(0,"Resistance-2_week",OBJ_HLINE,0,0,R2S);
   ObjectSet("Resistance-2_week",OBJPROP_STYLE,5);
   ObjectSet("Resistance-2_week",OBJPROP_COLOR,fibPoints_R_Color_Week);
   ObjectSet("Resistance-2_week", OBJPROP_SELECTABLE, false);
   
   ObjectDelete("Resistance-1_week");
   ObjectCreate(0,"Resistance-1_week",OBJ_HLINE,0,0,R1S);
   ObjectSet("Resistance-1_week",OBJPROP_STYLE,5);
   ObjectSet("Resistance-1_week",OBJPROP_COLOR,fibPoints_R_Color_Week);
   ObjectSet("Resistance-1_week", OBJPROP_SELECTABLE, false);
   
   ObjectDelete("Support-1_week");
   ObjectCreate(0,"Support-1_week",OBJ_HLINE,0,0,S1S);
   ObjectSet("Support-1_week",OBJPROP_STYLE,5);
   ObjectSet("Support-1_week",OBJPROP_COLOR,fibPoints_S_Color_Week);
   ObjectSet("Support-1_week", OBJPROP_SELECTABLE, false);
   
   ObjectDelete("Support-2_week");
   ObjectCreate(0,"Support-2_week",OBJ_HLINE,0,0,S2S);
   ObjectSet("Support-2_week",OBJPROP_STYLE,5);
   ObjectSet("Support-2_week",OBJPROP_COLOR,fibPoints_S_Color_Week);
   ObjectSet("Support-2_week", OBJPROP_SELECTABLE, false);
   
   ObjectDelete("Support-3_week");
   ObjectCreate(0,"Support-3_week",OBJ_HLINE,0,0,S3S);
   ObjectSet("Support-3_week",OBJPROP_STYLE,5);
   ObjectSet("Support-3_week",OBJPROP_COLOR,fibPoints_S_Color_Week);
   ObjectSet("Support-3_week", OBJPROP_SELECTABLE, false);
   
   }
//--------------------------------------------------------------------
// Pivot Fibonacci - Mensal

 if (show_Fibo_Point_Monthly==true)
   {     
   double R3M,R2M,R1M,PivotM,S1M,S2M,S3M;  

   PivotM=(MN1_high+MN1_low+MN1_close)/3;
   
   R3M=PivotM+(MN1_high-MN1_low)*1.000;
   R2M=PivotM+(MN1_high-MN1_low)*0.618;
   R1M=PivotM+(MN1_high-MN1_low)*0.382;

   S1M=PivotM-(MN1_high-MN1_low)*0.382;
   S2M=PivotM-(MN1_high-MN1_low)*0.618;
   S3M=PivotM-(MN1_high-MN1_low)*1.000; 
   
   //---------------------------------------------------------
   
   objName=uniqueid+"R3M";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],R3M,Time[0],R3M);
   ObjectSet(objName, OBJPROP_TIME1,  curTime+shift);
   ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet(objName, OBJPROP_STYLE, 2); 
   ObjectSet(objName, OBJPROP_COLOR, fibPoints_R_Color_Monthly);
   ObjectSet(objName, OBJPROP_BACK,true);
   ObjectSet(objName, OBJPROP_SELECTABLE, false);
   ObjectSet(objName, OBJPROP_RAY, false);
      
   //---------------------------------------------------------
   
   objName=uniqueid+"R2M";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],R2M,Time[0],R2M);
   ObjectSet(objName, OBJPROP_TIME1,  curTime+shift);
   ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet(objName, OBJPROP_STYLE,2);
   ObjectSet(objName, OBJPROP_COLOR,fibPoints_R_Color_Monthly);
   ObjectSet(objName, OBJPROP_BACK,true);
   ObjectSet(objName, OBJPROP_SELECTABLE,false);
   ObjectSet(objName, OBJPROP_RAY, false);
   
 
   //---------------------------------------------------------
   
   objName=uniqueid+"R1M";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],R1M,Time[0],R1M);
   ObjectSet(objName, OBJPROP_TIME1,  curTime+shift);
   ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet(objName, OBJPROP_STYLE,2);
   ObjectSet(objName, OBJPROP_COLOR,fibPoints_R_Color_Monthly);
   ObjectSet(objName, OBJPROP_BACK,true);
   ObjectSet(objName, OBJPROP_SELECTABLE,false);
   ObjectSet(objName, OBJPROP_RAY, false);
    
   
   //---------------------------------------------------------
   
   objName=uniqueid+"S3M";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],S3M,Time[0],S3M);
   ObjectSet(objName, OBJPROP_TIME1,  curTime+shift);
   ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet(objName, OBJPROP_STYLE,2); 
   ObjectSet(objName, OBJPROP_COLOR,fibPoints_S_Color_Monthly);
   ObjectSet(objName, OBJPROP_BACK,true);
   ObjectSet(objName, OBJPROP_SELECTABLE,false);
   ObjectSet(objName, OBJPROP_RAY, false);
   
   
   //---------------------------------------------------------
   
   objName=uniqueid+"S2M";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],S2M,Time[0],S2M);
   ObjectSet(objName, OBJPROP_TIME1,  curTime+shift);
   ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet(objName, OBJPROP_STYLE,2); 
   ObjectSet(objName, OBJPROP_COLOR,fibPoints_S_Color_Monthly);
   ObjectSet(objName, OBJPROP_BACK,true);
   ObjectSet(objName, OBJPROP_SELECTABLE,false);
   ObjectSet(objName, OBJPROP_RAY, false);
   
   
   //---------------------------------------------------------
   
   objName=uniqueid+"S1M";
   ObjectDelete(objName);
   ObjectCreate(NULL,objName,OBJ_TREND,0,Time[100],S1M,Time[0],S1M);
   ObjectSet(objName, OBJPROP_TIME1,  curTime+shift);
   ObjectSet(objName, OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet(objName, OBJPROP_STYLE,2); 
   ObjectSet(objName, OBJPROP_COLOR,fibPoints_S_Color_Monthly);
   ObjectSet(objName, OBJPROP_BACK,true);
   ObjectSet(objName, OBJPROP_SELECTABLE,false);
   ObjectSet(objName, OBJPROP_RAY, false);
   
   }
  if (show_Fibo_Point_Monthly_Price==true) 
   { 
   ObjectDelete("Resistance-3_monthly");
   ObjectCreate(0,"Resistance-3_monthly",OBJ_HLINE,0,0,R3M);
   ObjectSet("Resistance-3_monthly",OBJPROP_STYLE,5);
   ObjectSet("Resistance-3_monthly",OBJPROP_COLOR,fibPoints_R_Color_Monthly);
   ObjectSet("Resistance-3_monthly", OBJPROP_SELECTABLE, false);
   
   ObjectDelete("Resistance-2_monthly");
   ObjectCreate(0,"Resistance-2_monthly",OBJ_HLINE,0,0,R2M);
   ObjectSet("Resistance-2_monthly",OBJPROP_STYLE,5);
   ObjectSet("Resistance-2_monthly",OBJPROP_COLOR,fibPoints_R_Color_Monthly);
   ObjectSet("Resistance-2_monthly", OBJPROP_SELECTABLE, false);
   
   ObjectDelete("Resistance-1_monthly");
   ObjectCreate(0,"Resistance-1_monthly",OBJ_HLINE,0,0,R1M);
   ObjectSet("Resistance-1_monthly",OBJPROP_STYLE,5);
   ObjectSet("Resistance-1_monthly",OBJPROP_COLOR,fibPoints_R_Color_Monthly);
   ObjectSet("Resistance-1_monthly", OBJPROP_SELECTABLE, false);
   
   ObjectDelete("Support-1_monthly");
   ObjectCreate(0,"Support-1_monthly",OBJ_HLINE,0,0,S1M);
   ObjectSet("Support-1_monthly",OBJPROP_STYLE,5);
   ObjectSet("Support-1_monthly",OBJPROP_COLOR,fibPoints_S_Color_Monthly);
   ObjectSet("Support-1_monthly", OBJPROP_SELECTABLE, false);
   
   ObjectDelete("Support-2_monthly");
   ObjectCreate(0,"Support-2_monthly",OBJ_HLINE,0,0,S2M);
   ObjectSet("Support-2_monthly",OBJPROP_STYLE,5);
   ObjectSet("Support-2_monthly",OBJPROP_COLOR,fibPoints_S_Color_Monthly);
   ObjectSet("Support-2_monthly", OBJPROP_SELECTABLE, false);
   
   ObjectDelete("Support-3_monthly");
   ObjectCreate(0,"Support-3_monthly",OBJ_HLINE,0,0,S3M);
   ObjectSet("Support-3_monthly",OBJPROP_STYLE,5);
   ObjectSet("Support-3_monthly",OBJPROP_COLOR,fibPoints_S_Color_Monthly);
   ObjectSet("Support-3_monthly", OBJPROP_SELECTABLE, false);
   
   }
//-----------------------------------------------------------
//   Weekly high/low   
   
 if (W1_Show_Line==true) 
   { 
   ObjectDelete("Weekly_High_");
   ObjectCreate(0,"Weekly_High_",OBJ_TREND,0,0,0,0);
   ObjectSet("Weekly_High_", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("Weekly_High_", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("Weekly_High_", OBJPROP_PRICE1, W1_high);
   ObjectSet("Weekly_High_", OBJPROP_PRICE2, W1_high);
   ObjectSet("Weekly_High_",OBJPROP_STYLE, W1_style);
   ObjectSet("Weekly_High_",OBJPROP_COLOR, W1_Highcol);
   ObjectSet("Weekly_High_",OBJPROP_RAY,false);
   
   ObjectDelete("Weekly_Low_");
   ObjectCreate(0,"Weekly_Low_",OBJ_TREND,0,0,0,0);
   ObjectSet("Weekly_Low_", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("Weekly_Low_", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("Weekly_Low_", OBJPROP_PRICE1, W1_low);
   ObjectSet("Weekly_Low_", OBJPROP_PRICE2, W1_low);
   ObjectSet("Weekly_Low_",OBJPROP_STYLE, W1_style);
   ObjectSet("Weekly_Low_",OBJPROP_COLOR, W1_Lowcol);
   ObjectSet("Weekly_Low_",OBJPROP_RAY,false);
   }
   
 if (W1_Show_Price==true) 
   { 
   ObjectDelete("Weekly_High");
   ObjectCreate(0,"Weekly_High",OBJ_HLINE,0,0,W1_high);
   ObjectSet("Weekly_High",OBJPROP_STYLE,5);
   ObjectSet("Weekly_High",OBJPROP_COLOR, W1_Highcol);
   
   ObjectDelete("Weekly_Low");
   ObjectCreate(0,"Weekly_Low",OBJ_HLINE,0,0,W1_low);
   ObjectSet("Weekly_Low",OBJPROP_STYLE,5);
   ObjectSet("Weekly_Low",OBJPROP_COLOR, W1_Lowcol);
   }
   
//--------------------------------------------------------------------
//   Monthly high/low  
   
 if (MN1_Show_Line==true) 
   { 
   ObjectDelete("Monthly_High_");
   ObjectCreate(0,"Monthly_High_",OBJ_TREND,0,0,0,0);
   ObjectSet("Monthly_High_", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("Monthly_High_", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("Monthly_High_", OBJPROP_PRICE1, MN1_high);
   ObjectSet("Monthly_High_", OBJPROP_PRICE2, MN1_high);
   ObjectSet("Monthly_High_",OBJPROP_STYLE, MN1_style);
   ObjectSet("Monthly_High_",OBJPROP_COLOR, MN1_Highcol);
   ObjectSet("Monthly_High_",OBJPROP_RAY,false);
   
   ObjectDelete("Monthly_Low_");
   ObjectCreate(0,"Monthly_Low_",OBJ_TREND,0,0,0,0);
   ObjectSet("Monthly_Low_", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("Monthly_Low_", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("Monthly_Low_", OBJPROP_PRICE1, MN1_low);
   ObjectSet("Monthly_Low_", OBJPROP_PRICE2, MN1_low);
   ObjectSet("Monthly_Low_",OBJPROP_STYLE, MN1_style);
   ObjectSet("Monthly_Low_",OBJPROP_COLOR, MN1_Lowcol);
   ObjectSet("Monthly_Low_",OBJPROP_RAY,false);
   }
   
 if (MN1_Show_Price==true) 
   { 
   ObjectDelete("Monthly_High");
   ObjectCreate(0,"Monthly_High",OBJ_HLINE,0,0,MN1_high);
   ObjectSet("Monthly_High",OBJPROP_STYLE,5);
   ObjectSet("Monthly_High",OBJPROP_COLOR, MN1_Highcol);
   
   ObjectDelete("Monthly_Low");
   ObjectCreate(0,"Monthly_Low",OBJ_HLINE,0,0,MN1_low);
   ObjectSet("Monthly_Low",OBJPROP_STYLE,5);
   ObjectSet("Monthly_Low",OBJPROP_COLOR, MN1_Lowcol);
   }

//--------------------------------------------------------------------
//   X Daily high/low

   double XD1_high=iHigh(NULL, PERIOD_D1,1); 
   double XD1_low=iLow(NULL, PERIOD_D1,1);     
   
 if (XD1_Show_Line==true) 
   { 
   ObjectDelete("X_Daily_High_");
   ObjectCreate(0,"X_Daily_High_",OBJ_TREND,0,0,0,0);
   ObjectSet("X_Daily_High_", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("X_Daily_High_", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("X_Daily_High_", OBJPROP_PRICE1, XD1_high);
   ObjectSet("X_Daily_High_", OBJPROP_PRICE2, XD1_high);
   ObjectSet("X_Daily_High_",OBJPROP_STYLE, XD1_style);
   ObjectSet("X_Daily_High_",OBJPROP_COLOR, XD1_Highcol);
   ObjectSet("X_Daily_High_",OBJPROP_RAY,false);
   
   ObjectDelete("X_Daily_Low_");
   ObjectCreate(0,"X_Daily_Low_",OBJ_TREND,0,0,0,0);
   ObjectSet("X_Daily_Low_", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("X_Daily_Low_", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("X_Daily_Low_", OBJPROP_PRICE1, XD1_low);
   ObjectSet("X_Daily_Low_", OBJPROP_PRICE2, XD1_low);
   ObjectSet("X_Daily_Low_",OBJPROP_STYLE, XD1_style);
   ObjectSet("X_Daily_Low_",OBJPROP_COLOR, XD1_Lowcol);
   ObjectSet("X_Daily_Low_",OBJPROP_RAY,false);
   }
   
 if (XD1_Show_Price==true) 
   { 
   ObjectDelete("X_Daily_High");
   ObjectCreate(0,"X_Daily_High",OBJ_HLINE,0,0,XD1_high);
   ObjectSet("X_Daily_High",OBJPROP_STYLE,5);
   ObjectSet("X_Daily_High",OBJPROP_COLOR, XD1_Highcol);
   
   ObjectDelete("X_Daily_Low");
   ObjectCreate(0,"X_Daily_Low",OBJ_HLINE,0,0,XD1_low);
   ObjectSet("X_Daily_Low",OBJPROP_STYLE,5);
   ObjectSet("X_Daily_Low",OBJPROP_COLOR, XD1_Lowcol);
   }

//--------------------------------------------------------------------
//    Daily Open

   double D1_Open=iOpen(NULL, PERIOD_D1,0);   
   
 if (Open_Show_Line==true) 
   { 
   ObjectDelete("Daily_Open_");
   ObjectCreate(0,"Daily_Open_",OBJ_TREND,0,0,0,0);
   ObjectSet("Daily_Open_", OBJPROP_TIME1,  curTime+shift);
   ObjectSet("Daily_Open_", OBJPROP_TIME2,  curTime+shift+width2);
   ObjectSet("Daily_Open_", OBJPROP_PRICE1, D1_Open);
   ObjectSet("Daily_Open_", OBJPROP_PRICE2, D1_Open);
   ObjectSet("Daily_Open_",OBJPROP_STYLE, Open_style);
   ObjectSet("Daily_Open_",OBJPROP_COLOR, Open_col);
   ObjectSet("Daily_Open_",OBJPROP_RAY,false);
   }
   
 if (Open_Show_Price==true) 
   { 
   ObjectDelete("Daily_Open");
   ObjectCreate(0,"Daily_Open",OBJ_HLINE,0,0,D1_Open);
   ObjectSet("Daily_Open",OBJPROP_STYLE,5);
   ObjectSet("Daily_Open",OBJPROP_COLOR, Open_col);
   } 
     
//--------------------------------------------------------------------
//   Daily Info

 if (Show_Daily_Info==true)
   { 
   double  D1_open=iOpen(NULL, PERIOD_D1,0); 
   double  D1_Range=(D1_high-D1_low)/Point;
   double  D1_Change=(Bid-D1_open)/Point;
   
   color D1CCol;
   
   if (Bid > D1_open)D1CCol= C'153,175,251';
   if (Bid < D1_open)D1CCol= clrOrange;   
   
      ObjectCreate(0,"D1Range",OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,"D1Range",OBJPROP_CORNER,0);
   ObjectSetInteger(0,"D1Range",OBJPROP_BORDER_COLOR,C'155,155,155');
   ObjectSetInteger(0,"D1Range",OBJPROP_BGCOLOR,C'32,41,49');
   ObjectSetInteger(0,"D1Range",OBJPROP_XDISTANCE,12);
   ObjectSetInteger(0,"D1Range",OBJPROP_YDISTANCE,-1);
   ObjectSetInteger(0,"D1Range",OBJPROP_XSIZE,40);
   ObjectSetInteger(0,"D1Range",OBJPROP_YSIZE,15);
   ObjectSetInteger(0,"D1Range",OBJPROP_COLOR,C'243,239,199');
   ObjectSetInteger(0,"D1Range",OBJPROP_FONTSIZE,9);
   ObjectSetString(0,"D1Range",OBJPROP_TEXT,DoubleToString(NormalizeDouble(D1_Range / divider, 1), x_digits));
   ObjectSetString(0,"D1Range",OBJPROP_FONT, "Arial Black");
   ObjectSetInteger(0,"D1Range",OBJPROP_SELECTABLE,false);
   ObjectSetInteger(0,"D1Range",OBJPROP_HIDDEN,True); 
   
      ObjectCreate(0,"D1Change",OBJ_BUTTON,0,0,0);
   ObjectSetInteger(0,"D1Change",OBJPROP_CORNER,0);
   ObjectSetInteger(0,"D1Change",OBJPROP_BORDER_COLOR,C'155,155,155');
   ObjectSetInteger(0,"D1Change",OBJPROP_BGCOLOR,C'32,41,49');
   ObjectSetInteger(0,"D1Change",OBJPROP_XDISTANCE,52);
   ObjectSetInteger(0,"D1Change",OBJPROP_YDISTANCE,-1);
   ObjectSetInteger(0,"D1Change",OBJPROP_XSIZE,40);
   ObjectSetInteger(0,"D1Change",OBJPROP_YSIZE,15);
   ObjectSetInteger(0,"D1Change",OBJPROP_COLOR,D1CCol);
   ObjectSetInteger(0,"D1Change",OBJPROP_FONTSIZE,9);
   ObjectSetString(0,"D1Change",OBJPROP_TEXT,DoubleToString(NormalizeDouble(D1_Change / divider, 1), x_digits));
   ObjectSetString(0,"D1Change",OBJPROP_FONT, "Arial Black");
   ObjectSetInteger(0,"D1Change",OBJPROP_SELECTABLE,false);
   ObjectSetInteger(0,"D1Change",OBJPROP_HIDDEN,True); 
   }
   
//----------------------------------------------------
// BB Candlestick 

   if(Show_BB_Candle==true) { 
    
      double BB_Up = iBands(NULL,PERIOD_M1,21,2,0,PRICE_CLOSE,MODE_UPPER,0);
      double BB_Down = iBands(NULL,PERIOD_M1,21,2,0,PRICE_CLOSE,MODE_LOWER,0);
      
   //-------------------------
      
      ObjectDelete("MA_21");
      ObjectCreate(0,"MA_21",OBJ_TREND,0,0,0,0);
      ObjectSet("MA_21", OBJPROP_TIME1,  curTime+BBshift);
      ObjectSet("MA_21", OBJPROP_TIME2,  curTime+BBshift+BBwidth);
      ObjectSet("MA_21", OBJPROP_PRICE1, SMA_21);
      ObjectSet("MA_21", OBJPROP_PRICE2, SMA_21);
      ObjectSet("MA_21",OBJPROP_STYLE,0);
      ObjectSet("MA_21",OBJPROP_COLOR,clrBlack);
      ObjectSet("MA_21",OBJPROP_RAY,false);   
      
      ObjectDelete(0,"SMA_21_DIS");
      ObjectCreate(0,"SMA_21_DIS",OBJ_RECTANGLE,0,0,0,0,0);
      ObjectSet("SMA_21_DIS", OBJPROP_TIME1,  curTime+BBshift);
      ObjectSet("SMA_21_DIS", OBJPROP_TIME2,  curTime+BBshift+BBwidth);
      ObjectSet("SMA_21_DIS", OBJPROP_PRICE1, SMA_21 );
      ObjectSet("SMA_21_DIS", OBJPROP_PRICE2, Bid );
      if(Bid>BB_Up)ObjectSet("SMA_21_DIS", OBJPROP_PRICE2, BB_Up);   
      if(Bid<BB_Down)ObjectSet("SMA_21_DIS", OBJPROP_PRICE2, BB_Down);
      color bodyCol;
      if(Bid>SMA_21)bodyCol=BullCol;
      if(Bid<SMA_21)bodyCol=BearCol;
      ObjectSet("SMA_21_DIS", OBJPROP_COLOR,  bodyCol );  
   
      ObjectDelete(0,"BBHigh_Area_0");
      if (Bid<BB_Up){
         ObjectCreate(0,"BBHigh_Area_0",OBJ_RECTANGLE,0,0,0,0,0);
         ObjectSet("BBHigh_Area_0", OBJPROP_TIME1,  curTime+BBshift);
         ObjectSet("BBHigh_Area_0", OBJPROP_TIME2,  curTime+BBshift+BBwidth);
         ObjectSet("BBHigh_Area_0", OBJPROP_PRICE1, BB_Up );
         if(Bid>SMA_21){ObjectSet("BBHigh_Area_0", OBJPROP_PRICE2, Bid );}
         if(Bid<SMA_21){ObjectSet("BBHigh_Area_0", OBJPROP_PRICE2, SMA_21 );}   
         ObjectSet("BBHigh_Area_0", OBJPROP_COLOR,  TailCol);  
      }
      
      ObjectDelete(0,"BBLow_Area_0");
      if (Bid>BB_Down){
         ObjectCreate(0,"BBLow_Area_0",OBJ_RECTANGLE,0,0,0,0,0);
         ObjectSet("BBLow_Area_0", OBJPROP_TIME1,  curTime+BBshift);
         ObjectSet("BBLow_Area_0", OBJPROP_TIME2,  curTime+BBshift+BBwidth);
         ObjectSet("BBLow_Area_0", OBJPROP_PRICE1, BB_Down );
         if(Bid<SMA_21){ObjectSet("BBLow_Area_0", OBJPROP_PRICE2, Bid );}
         if(Bid>SMA_21){ObjectSet("BBLow_Area_0", OBJPROP_PRICE2, SMA_21 );}   
         ObjectSet("BBLow_Area_0", OBJPROP_COLOR,  TailCol);  
      }
      
      //---------
       
      ObjectDelete(0,"BBHigh_Area");
      if (Bid>BB_Up){
         ObjectCreate(0,"BBHigh_Area",OBJ_RECTANGLE,0,0,0,0,0);
         ObjectSet("BBHigh_Area", OBJPROP_TIME1,  curTime+BBshift);
         ObjectSet("BBHigh_Area", OBJPROP_TIME2,  curTime+BBshift+BBwidth);
         ObjectSet("BBHigh_Area", OBJPROP_PRICE1, BB_Up );
         ObjectSet("BBHigh_Area", OBJPROP_PRICE2, Bid );
         ObjectSet("BBHigh_Area", OBJPROP_COLOR,  OBCol);  
      }
      
      ObjectDelete(0,"BBLow_Area");
      if (Bid<BB_Down){
         ObjectCreate(0,"BBLow_Area",OBJ_RECTANGLE,0,0,0,0,0);
         ObjectSet("BBLow_Area", OBJPROP_TIME1,  curTime+BBshift);
         ObjectSet("BBLow_Area", OBJPROP_TIME2,  curTime+BBshift+BBwidth);
         ObjectSet("BBLow_Area", OBJPROP_PRICE1, BB_Down );
         ObjectSet("BBLow_Area", OBJPROP_PRICE2, Bid );
         ObjectSet("BBLow_Area", OBJPROP_COLOR,  OSCol);  
      }
   }
   drawTimeFrameHeader();
  
//--------------------------------------------------------------------------     
return(0);
}


void drawTimeFrameHeader(){
   // Time frame text
   
   objName=uniqueid+"TF_BG";
   ObjectDelete(NULL,objName);
   ObjectCreate(NULL,objName, OBJ_RECTANGLE_LABEL, 0, 0, 0);
   ObjectSetInteger(NULL,objName,OBJPROP_CORNER,CORNER_RIGHT_LOWER);  // CORNER_RIGHT_UPPER
   ObjectSetInteger(NULL,objName,OBJPROP_XDISTANCE,Width2+3);
   ObjectSetInteger(NULL,objName,OBJPROP_YDISTANCE,12);
   ObjectSetInteger(NULL,objName,OBJPROP_XSIZE,Width2+2);
   ObjectSetInteger(NULL,objName,OBJPROP_YSIZE,15);
   ObjectSetInteger(NULL,objName,OBJPROP_COLOR,Black);
   ObjectSetInteger(NULL,objName,OBJPROP_BGCOLOR,C'32,41,49');
   ObjectSetInteger(0,objName,OBJPROP_STYLE,STYLE_SOLID);
   ObjectSetInteger(0,objName,OBJPROP_BACK,false);
   ObjectSetInteger(0,objName,OBJPROP_BORDER_TYPE,BORDER_RAISED);
   ObjectSetInteger(0,objName,OBJPROP_SELECTABLE,0);

   for (tf=0;tf<NTF;tf++){   
      objName = uniqueid+"TF_"+tf;
      ObjectDelete(NULL,objName);
      ObjectCreate(NULL,objName ,OBJ_LABEL, 0, 0, 0, 0, 0);
      
      ObjectSetString(NULL,objName, OBJPROP_FONT, "Arial Narrow");
      ObjectSetInteger(NULL,objName, OBJPROP_FONTSIZE,8);
      ObjectSetInteger(NULL,objName,OBJPROP_CORNER,CORNER_RIGHT_LOWER);
      
      ObjectSet(objName, OBJPROP_XDISTANCE, VWidth*(NTF-tf)-0.9);   
      ObjectSet(objName, OBJPROP_YDISTANCE, 13); 
      ObjectSet(objName, OBJPROP_COLOR, clrBisque);
      ObjectSet(objName, OBJPROP_BACK,false);
           
      int val=tfp[tf]/60;
      if (val<1) ObjectSetText(objName, IntegerToString(tfp[tf])+"M");
      else if (val==1) ObjectSetText(objName,"1H");
      else if (val==4) ObjectSetText(objName, "4H");
      else if (val==24) ObjectSetText(objName, "1D");
      else if (val==168) ObjectSetText(objName, "1W"); 
      else if (val>=720) ObjectSetText(objName, "MN");
   }
}


void initializeArrays() {
   NTF = numTimeFrames;
   if (NTF < 1) NTF = 1;
   else if (NTF > 9) NTF = 9;
   
   Width2 = VWidth * NTF;
   Shift  = - (VWidth * NTF - 1);
   BBShift = - (VWidth * NTF + BBWidth);
   ArrayResize(fma, NTF);
   ArrayResize(fib_up, NTF);
   ArrayResize(fib_down, NTF);
   ArrayResize(tfp, NTF);
   for(tf=0; tf<NTF; tf++)
   {
      tfp[tf] = allTFP[tf];
   }
}

